(require 'hi-lock)

(defvar hi-lock-patterns-file nil)
;; use as buffer or dir local variable

(defun get-patterns-from-file (file)
  (with-current-buffer
      (find-file-noselect file)
    (ignore-errors ;empty file
      (read (buffer-string)))))

(advice-add
 'hi-lock-find-patterns :after
 (lambda (&rest _)
   (hi-lock-set-file-patterns
    (append hi-lock-file-patterns
	    (and hi-lock-patterns-file
		 (get-patterns-from-file
		  (expand-file-name hi-lock-patterns-file)))))))

(defun hi-lock-write-patterns-file ()
  "Use this instead of `hi-lock-write-interactive-patterns'."
  (interactive)
  (let ((new-patterns (copy-sequence hi-lock-interactive-patterns)))
    (with-current-buffer (find-file-noselect hi-lock-patterns-file)
      (let ((old-patterns (ignore-errors ;empty file
			    (read (buffer-string)))))
	(erase-buffer)
	(insert (prin1-to-string
		 (delete-dups (append old-patterns
				      new-patterns))))
	(save-buffer)))))
